----------------------------------------------------------------------------------
-- Company: 
-- Engineer:       Davor Cihlar
-- 
-- Create Date:    23:15:13 06/11/2009 
-- Design Name: 
-- Module Name:    tbist - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity tbist is
	generic (init : STD_LOGIC := '1');
    Port ( clk : in  STD_LOGIC;
           rst : in  STD_LOGIC;
           d : out  STD_LOGIC);
end tbist;

architecture Behavioral of tbist is
begin

	process (clk, rst)
		variable b : STD_LOGIC := init;
	begin
		if (rst = '1') then
			b := init;
		elsif (falling_edge(clk)) then
			b := not b;
		end if;
		
		d <= b;
	end process;

end Behavioral;

